<template>
  <q-modal
    :value="isActive"
    @hide="close"
    @show="focus"
    ref="modal"
  >
    <div class="q-pa-md">
      <div class="q-title">Add collection</div>
      <q-input
        v-model="collectionId"
        ref="field"
        :disable="isProcessing"
        float-label="Type collection ID"
        class="q-mt-sm"
      />
      <div class="flex justify-end q-mt-md">
        <q-btn
          v-close-overlay
          :disable="isProcessing"
          label="Cancel"
          color="red"
        />
        <q-btn
          @click="create"
          :disable="isProcessing"
          label="Create"
          color="green"
          class="q-ml-sm"
        />
      </div>
    </div>
  </q-modal>
</template>

<script>
    import notificationMixin from '../../../../../mixins/notificationMixin';
    import apiMixin from '../../../../../mixins/apiMixin';
    import { defaultCollectionConfig } from '../../../../../utilities/migrateConfig';

    export default {
      name: 'createCollection',
      mixins: [notificationMixin, apiMixin],
      props: {
        isActive: {
          type: Boolean,
        },
      },
      data() {
        return {
          collectionId: null,
          isProcessing: false,
        };
      },
      methods: {
        focus() {
          this.$nextTick(() => {
            this.$refs.field.focus();
          });
        },
        close() {
          this.collectionId = null;
          this.$emit('close');
        },
        create() {
          this.apiPost('collections/set', {
            collection_id: this.collectionId,
            collection_config: JSON.stringify(defaultCollectionConfig),
          })
            .then(({ Status, Message, message }) => {
              if (Status === 'Error') {
                this.notifyError({
                  message: Message || message,
                });
                this.focus();
              } else {
                this.notifyInfo({
                  message: `Collection ${ this.collectionId } has been created`,
                });
                this.$emit('created', this.collectionId);
                this.$refs.modal.hide();
              }
            })
            .catch(() => {
              this.notifyError({
                title: 'Unable to create collection',
              });
            });
        },
      },
    };
</script>

<style scoped>

</style>
